#-*- encoding: utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        palette.py
# Purpose:
#
# Author:      Eiichi Takebuchi(GRGSIBERIA)
#
# Created:     06/05/2011
# Copyright:   (c) Eiichi Takebuchi(GRGSIBERIA) 2011
# Licence:     <your licence>
#-------------------------------------------------------------------------------
#!/usr/bin/env python
from struct import *

class EdgePalette:
    def __getRGB(self, c):
        nums = c[:-1].split(',')
        result = []
        for o in nums:
            if len(nums) > 1: result.append(int(o))
        return result

    # NES準拠の64色をリストに出力
    def getPaletteColors(self):
        f = open("color64.csv", "r")
        colors = []

        while True:
            c = f.readline()
            if not c: break

            buf = self.__getRGB(c)
            if buf == 0: continue
            if len(buf) != 0: colors.append(buf)

        f.close()
        return colors

    def __initPalette(self, f):
        p = []
        f.write("EDGE PAL\0\0")
        for i in range(256):
            buf = []
            for j in range(3):
                buf.append(0)
            p.append(buf)
        return p

    def __burnPalette(self, f, c, p, n):
        for i in range(len(c)):
            p[i+n] = c[i]

        for o in p:
            for e in o:
                f.write(pack("<B", e))

    # 前半32色が空で、残り64色がNES準拠のパレットファイルを出力
    def createEdgePalette64(self, filename):
        f = open(filename, "wb")
        c = self.getPaletteColors()

        p = self.__initPalette(f)
        self.__burnPalette(f, c, p, 32)

        f.close()

    def __openEdgePalette(self, f):
        p = []
        f.seek(10)
        for i in range(32):
            c = []
            for j in range(3):
                c.append(unpack("!B", f.read(1))[0])
            p.append(c)
        return p

    # 32色分のパレットを読み込み
    def loadEdgePalette32(self, filename):
        f = open(filename, "rb")
        pal = self.__openEdgePalette(f)
        f.close()
        return pal
